# Generated by Django 4.2.3 on 2023-09-27 20:01

import core.models.validator
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('core', '0044_api_topics'),
    ]

    operations = [
        migrations.CreateModel(
            name='Validator',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('validator_id', models.CharField(max_length=50)),
                ('name', models.CharField(max_length=50)),
                ('description', models.TextField()),
                ('version', models.CharField(max_length=16)),
                ('documentation_url', models.URLField(null=True)),
            ],
        ),
        migrations.CreateModel(
            name='ValidatorReport',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uri', models.CharField(max_length=200)),
                ('generated_at', models.DateTimeField(auto_now_add=True)),
                ('rule_passed_count', models.PositiveIntegerField(default=0)),
                ('rule_total_count', models.PositiveIntegerField(default=0)),
            ],
        ),
        migrations.CreateModel(
            name='APIValidatorReport',
            fields=[
                ('report', models.OneToOneField(db_column='validator_report_id', on_delete=django.db.models.deletion.CASCADE, primary_key=True, related_name='+', serialize=False, to='core.validatorreport')),
                ('is_latest', models.BooleanField(default=False)),
            ],
            options={
                'ordering': ('-report__generated_at',),
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ValidatorRuleset',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('ruleset_id', models.CharField(max_length=50)),
                ('title', models.CharField(max_length=100)),
                ('description', models.TextField()),
                ('version', models.CharField(max_length=16)),
                ('documentation_url', models.URLField(null=True)),
                ('validator', models.ForeignKey(on_delete=django.db.models.deletion.RESTRICT, related_name='rulesets', to='core.validator')),
            ],
        ),
        migrations.CreateModel(
            name='ValidatorRule',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rule_id', models.CharField(max_length=50)),
                ('title', models.CharField(max_length=100)),
                ('description', models.TextField()),
                ('documentation_url', models.URLField(null=True)),
                ('ruleset', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='rules', to='core.validatorruleset')),
            ],
        ),
        migrations.CreateModel(
            name='ValidatorResult',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('passed', models.BooleanField()),
                ('message', models.CharField(blank=True, max_length=500)),
                ('details', models.TextField(blank=True)),
                ('report', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='results', to='core.validatorreport')),
                ('rule', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='results', to='core.validatorrule')),
            ],
        ),
        migrations.AddField(
            model_name='validatorreport',
            name='ruleset',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='reports', to='core.validatorruleset'),
        ),
        migrations.AddConstraint(
            model_name='validatorruleset',
            constraint=models.UniqueConstraint(fields=('ruleset_id', 'validator'), name='unique_ruleset_per_validator'),
        ),
        migrations.AddConstraint(
            model_name='validatorrule',
            constraint=models.UniqueConstraint(fields=('rule_id', 'ruleset'), name='unique_rule_per_ruleset'),
        ),
        migrations.AddField(
            model_name='apivalidatorreport',
            name='api',
            field=core.models.validator.ForeignValidatorReport(on_delete=django.db.models.deletion.CASCADE, related_name='validator_reports', to='core.api'),
        ),
    ]
